<?php
/*
This file is part of miniBB. miniBB is free discussion forums/message board software, supplied with no warranties.
Check COPYING file for more details.
Copyright (C) 2007 Paul Puzyrev. www.minibb.com
Latest File Update: 2023-05-17
*/

function enCodeBBSig($msg,$admin) {

$pattern=array(); $replacement=array();

$pattern[]="/\[url=((f|ht)tp[s]?:\/\/[^<> \n\r\[\]]+?)\](.*?)\[\/url\]/i";
$replacement[]="<a href=\"\\1\" target=\"_blank\" rel=\"nofollow\">\\3</a>";

/* [IMGS] tag code - with fixed width and ALT */
$pattern[]="/\[img=(http[s]*:\/\/([^<> \n\r\[\]&\#]+?)\.?(gif|jpg|jpeg|png|svg)?)\]([^<>\n\r\[\]=']*?)\[\/img\]/i";
$replacement[]='<img src="\\1" alt="\\4" title="\\4">';

$pattern[]="/\[[bB]\](.+?)\[\/[bB]\]/s";
$replacement[]='<strong>\\1</strong>';

$pattern[]="/\[[iI]\](.+?)\[\/[iI]\]/s";
$replacement[]='<em>\\1</em>';

$pattern[]="/\[[uU]\](.+?)\[\/[uU]\]/s";
$replacement[]='<u>\\1</u>';

$pattern[]="/\[font(#[A-F0-9]{6})\](.+?)\[\/font\]/is";
$replacement[]='<span style="color:\\1">\\2</span>';

if($admin==1 or $GLOBALS['isMod']==1){

$pattern[]="/\[urlc=((f|ht)tp[s]?:\/\/[^<> \n\r\[\]]+?)\](.*?)\[\/url\]/i";
$replacement[]="<a href=\"\\1\" target=\"_blank\">\\3</a>";

}

$msg=preg_replace($pattern, $replacement, $msg);
$msg=str_replace(array("\r\n", "\n"), $GLOBALS['brtag'], $msg);

if(substr_count($msg,'<img')>0) $msg=str_replace('align=""', '', $msg);
if(substr_count($msg,'"nofollow"></a>')>0) $msg=str_replace('"nofollow"></a>', '"nofollow">URL</a>', $msg);

return $msg;
}

//--------------->
function deCodeBBSig($msg) {

$pattern=array(); $replacement=array();

/* [IMGS] tag code - with fixed width and alt */ 
$pattern[]="/<img src=\"([^<> \n\r\[\]&\#]+?)\" alt=\"(.+?)\" (title=\"(.+?)\")?[ ]*\/*>/i";
$replacement[]="[img=\\1]\\4[/img]";

$pattern[]="/<a href=\"([^<> \n\r\[\]]+?)\" target=\"(_new|_blank)\" rel=\"nofollow\">(.+?)<\/a>/i";
$replacement[]="[url=\\1]\\3[/url]";

if($GLOBALS['user_id']==1 or (isset($GLOBALS['isMod']) and $GLOBALS['isMod']==1)){
$pattern[]="/<a href=\"([^<> \n\r\[\]]+?)\" target=\"(_new|_blank)\">(.+?)<\/a>/i";
$replacement[]="[urlc=\\1]\\3[/url]";
}
else{
$pattern[]="/<a href=\"([^<> \n\r\[\]]+?)\" target=\"(_new|_blank)\">(.+?)<\/a>/i";
$replacement[]="[url=\\1]\\3[/url]";
}

$pattern[]="/<strong>(.+?)<\/strong>/is";
$replacement[]="[b]\\1[/b]";

$pattern[]="/<em>(.+?)<\/em>/is";
$replacement[]="[i]\\1[/i]";

$pattern[]="/<[uU]>(.+?)<\/[uU]>/s";
$replacement[]="[u]\\1[/u]";

$pattern[]="/<span style=\"color:(#[A-F0-9]{6})\">(.+?)<\/span>/is";
$replacement[]='[font\\1]\\2[/font]';

$msg=preg_replace($pattern, $replacement, $msg);
$msg=str_replace(array('<br />', '<br>', '<wbr>'), array("\n", "\n", ''), $msg);
if(substr_count($msg, '[img\\2]')>0) $msg=str_replace('[img\\2]', '[img]', $msg);

return $msg;
}

?>